/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package coinserver;

import paymentsystem.Wallet;
import paymentsystem.Market;
import paymentsystem.PaymentSystem;
import menu.Menu;
import java.net.*;
import java.io.*;
import java.math.*;


class AcceptTelnetClient extends Thread {
    private BigInteger prime =       new BigInteger("101558939302851404456426761704353705658322742695488329836901999984373457836751");
    private BigInteger commonnumber = new BigInteger("72535531302939977163895671131946125079448816009282099533868737070972879400192");
    private Socket socket;
    private DataInputStream din;
    private DataOutputStream dout;
    private String wallet;
    private String pin;
    private java.security.SecureRandom rand = new java.security.SecureRandom();
    private PaymentSystem stock = null;
    private Menu menu = null;
    private String command = "";

    AcceptTelnetClient(Socket clientsocket, PaymentSystem mainstock) throws Exception {
        this.stock = mainstock;
        this.socket = clientsocket;            
        start();        
    }
  
    @Override
  public void run() {
     boolean allow = true;
     try {    
        BufferedReader br = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter pw = new PrintWriter(new OutputStreamWriter(socket.getOutputStream()));

        pw.println();
        pw.println("Welcome to the Color Coins payment system");
        pw.println();
        pw.println("A stable self-regulating economic model, excludes the illiquidity crisis");
        pw.println();
        pw.println("The imperfection of this model is rigidly centralized management for automated\n\rliquidity provider");
        pw.println();
        pw.println("White coins: fixed emission of 10000   coins"); 
        pw.println("Red   coins: fixed emission of 100000  coins"); 
        pw.println("Green coins: fixed emission of 1000000 coins"); 
        pw.println("Black coins: the emission of unlimited");
        pw.println();
        char useraction = '0';
        while(allow) {
            this.menu = new Menu();
            for (int i = 0; i < 3; i++) {
                this.menu.setPoint(i);
            }
            this.menu.addPoint("1. Open wallet");
            this.menu.addPoint("2. You can win a black coins");
            do {
                pw.println(this.menu);
                pw.flush();
                this.command = br.readLine().trim();
            } while (! this.menu.checkCommand(command));
            
            useraction = this.command.charAt(0);
            
            if (useraction == '2') {
                coinserver.blackjack.BlackjackConsole bj = new coinserver.blackjack.BlackjackConsole(br, pw);
            } else {
                if (useraction == '1') {
                    pw.println("Enter the number of wallet: ");
                    pw.flush();
                    String number = br.readLine().trim();
                    while (! this.isBigIntegerDigit(number)) {
                        pw.println();
                        pw.println("Invalid number");
                        pw.println();
                        pw.println("Enter the number of wallet: ");
                        pw.flush();
                        number = br.readLine().trim();
                    }
                    Wallet wallet = this.stock.getWallet(new BigInteger(number, 16));
                    if (wallet == null) {
                        pw.println();
                        pw.println("Such wallet does not exist: " + number);
                        pw.println();
                    } else {
                        pw.println();
                        pw.println("You have: ");
                        pw.println();
                        for (int i = 0; i < wallet.getCoinsCount(); i++) {
                            if (wallet.getCoins(i).compareTo(BigDecimal.ZERO) > 0) {
                                pw.println(wallet.getCoinName(i) + " coins: " + wallet.getCoins(i));
                            }
                        }
                        pw.println();
                        BigInteger publickey = wallet.getNumber();
                        BigInteger secret = new BigInteger(publickey.bitLength(), this.rand);
                        BigInteger checknumber = publickey.modPow(secret, this.prime);
                        BigInteger control = this.commonnumber.modPow(secret, this.prime);
                        pw.println("Control number: " + control.toString(16));
                        pw.println("Enter the PIN code of wallet: ");
                        pw.flush();
                        String pin = br.readLine().trim();
                        if (! this.isBigIntegerDigit(pin)) {
                            useraction = '0';
                            pw.println();
                            pw.println("Invalid PIN code: " + pin);
                        } else {
                            if (new BigInteger(pin, 16).compareTo(checknumber) != 0) {
                                useraction = '0';
                                pw.println();
                                pw.println("Invalid PIN code: " + pin);
                                pw.flush();
                            }
                            if (useraction != '0') {
                                pw.println();
                                pw.println("Checking the secret key is successful");
                                pw.println();
                                boolean walletflag = true;
                                    while (walletflag) {
                                        pw.println();
                                        pw.println("You have: ");
                                        pw.println();
                                        for (int i = 0; i < wallet.getCoinsCount(); i++) {
                                            if (wallet.getCoins(i).compareTo(BigDecimal.ZERO) > 0) {
                                                pw.println(wallet.getCoinName(i) + " coins: " + wallet.getCoins(i));
                                            }
                                        }
                                        this.menu = new Menu(); 
                                        this.menu.setPoint(0);
                                        if (wallet.isHaveConvertCoins()) {
                                            this.menu.addPoint("1. Split the wallet");
                                            this.menu.setPoint(1);
                                        }
                                        this.menu.addPoint("2. To join with the wallet");
                                        this.menu.setPoint(2);
                                        for (int i = 0; i < wallet.getCoinsCount(); i++) {
                                            int n = i + 3;
                                            if (wallet.isHaveCoinsExcept(i)) {
                                                this.menu.addPoint(n + ". Buy " + wallet.getCoinName(i) + " coins");
                                                this.menu.setPoint(n);
                                            }
                                        }
                                        do {
                                            pw.println(this.menu);
                                            pw.flush();
                                            this.command = br.readLine().trim();
                                        } while (! this.menu.checkCommand(this.command));
                                        useraction = this.command.charAt(0);
                                        if ((useraction == '1') && (wallet.isHaveConvertCoins())) {
                                            // Разъединяем кошельки
                                            this.menu = new Menu();
                                            for (int i = 0; i < (wallet.getCoinsCount() - 1); i++) {
                                                if (wallet.isHaveConvertCoins(i)) {
                                                    int n = i + 1;
                                                    this.menu.addPoint(n + ". Send " + wallet.getCoinName(i) + " coins");
                                                    this.menu.setPoint(n);
                                                }
                                            }
                                            do {
                                                pw.println(this.menu);
                                                pw.flush();
                                                this.command = br.readLine().trim();
                                            } while (! this.menu.checkCommand(this.command));
                                            int currency = Integer.parseInt(this.command);
                                            if ((currency > 0) && (currency < (wallet.getCoinsCount()))) {
                                                pw.println();
                                                pw.println("You have " + wallet.getCoins(currency - 1) + " " + wallet.getCoinName(currency - 1) +  " coins");
                                                pw.println();
                                                pw.println("Amount: ");
                                                pw.flush();
                                                String amt = br.readLine().trim().replace(',', '.');
                                                while (! this.isDigit(amt)) {
                                                    pw.println();
                                                    pw.println("The input value of amount is not a number");
                                                    pw.println();
                                                    pw.println("You have " + wallet.getCoins(currency - 1) + " " + wallet.getCoinName(currency - 1) +  " coins");
                                                    pw.println("Amount: ");
                                                    pw.flush();
                                                    amt = br.readLine().trim().replace(',', '.');
                                                }
                                                BigDecimal amount = new BigDecimal(amt);
                                                if (wallet.isCorrectAmount(amount, currency - 1)) {
                                                    pw.println("Enter the number of new wallet:");
                                                    pw.flush();
                                                    BigInteger number1 = new BigInteger(br.readLine().trim(), 16);
                                                    this.menu = new Menu();
                                                    this.menu.addPoint("1. Continue");
                                                    this.menu.setPoint(1);
                                                    do {
                                                        pw.println(this.menu);
                                                        pw.flush();
                                                        this.command = br.readLine().trim();
                                                    } while (! this.menu.checkCommand(this.command));
                                                    if (this.command.equals("1")) {
                                                        synchronized (wallet) {
                                                            if (wallet.isCorrectAmount(amount, currency - 1)) {
                                                                Wallet wallet1 = new Wallet(number1, this.stock.getLogsManager());
                                                                wallet.subtractCoins(amount, currency - 1, wallet1.getNumber());
                                                                wallet1.addCoins(amount, currency - 1);
                                                                pw.println();
                                                                pw.println(amount + " " + wallet.getCoinName(currency - 1) + " coins successfully transfered into a wallet: " + number1.toString(16));
                                                            } else {
                                                                pw.println();
                                                                pw.println("Amount of money transfer for " + wallet.getCoinName(currency - 1) + " coins more cash in your wallet");
                                                            }
                                                        }
                                                    }
                                                } else {
                                                    pw.println();
                                                    pw.println("Amount of money transfer for " + wallet.getCoinName(currency - 1) + " coins more cash in your wallet");
                                                }
                                            }
                                        } else {
                                            if (useraction == '2') {
                                                pw.println();
                                                pw.println("Note: All the coins in this wallet will be transferred to another wallet.");
                                                pw.println("This empy wallet will be removed.");
                                                pw.println();
                                                pw.println("Enter number wallet for receiving coins: ");
                                                pw.flush();
                                                String dest = br.readLine().trim();
                                                File f = new File(dest + ".txt");
                                                if (f.exists()) {
                                                    this.menu = new Menu();
                                                    this.menu.addPoint("1. Continue");
                                                    this.menu.setPoint(1);
                                                    do {
                                                        pw.println(this.menu);
                                                        pw.flush();
                                                        this.command = br.readLine().trim();
                                                    } while (! this.menu.checkCommand(this.command));
                                                    if (this.command.equals("1")) {
                                                        pw.println();
                                                        Wallet destinationwallet = this.stock.getWallet(new BigInteger(dest, 16));
                                                        synchronized (destinationwallet) {
                                                            synchronized (wallet) {
                                                                pw.println();
                                                                for (int i = 0; i < 4; i++) {
                                                                    BigDecimal amount = wallet.getCoins(i);
                                                                    if (amount.compareTo(BigDecimal.ZERO) > 0) {
                                                                        pw.println("Transfered " + amount + " " + wallet.getCoinName(i) + " coins");
                                                                        wallet.subtractCoins(amount, i, destinationwallet.getNumber());
                                                                        destinationwallet.addCoins(amount, i);
                                                                    }
                                                                }
                                                                pw.println();
                                                                pw.flush();
                                                                this.stock.deleteWallet(wallet.getNumber(), new BigInteger(pin, 16));
                                                                useraction = '0';
                                                            }                                                    
                                                        } 
                                                    }
                                                } else {
                                                    pw.println();
                                                    pw.println("Such wallet does not exist: " + dest);
                                                    pw.println();
                                                    pw.flush();
                                                }
                                            } else {
                                                if ((useraction == '3') || (useraction == '4') || (useraction == '5') || (useraction == '6')) {
                                                    int currency = Integer.parseInt(command) - 3;
                                                    this.menu = new Menu();
                                                    Market market = this.stock.getMarket();
                                                    for (int i = 0; i < wallet.getCoinsCount(); i++) {
                                                        if ((i != (currency) && (wallet.getCoins(i).compareTo(BigDecimal.ZERO) > 0))) {
                                                            BigDecimal amount = wallet.getCoins(i);
                                                            int n = i + 1;
                                                            BigDecimal firstvolume = market.getPrice(currency, i, amount).multiply(amount).divide(BigDecimal.ONE, 6, BigDecimal.ROUND_DOWN);
                                                            BigDecimal price = firstvolume.divide(amount, 12, BigDecimal.ROUND_UP);
                                                            this.menu.addPoint(n + ". Sell " + amount + " " + wallet.getCoinName(i) + " coins, buy ~" + firstvolume + " " + wallet.getCoinName(currency) + " coins at price: 1 " + wallet.getCoinName(i) + " coin ~ " + price + " " + wallet.getCoinName(currency) + " coins");
                                                            this.menu.setPoint(n);
                                                        }
                                                    }
                                                    int lastpoint  = wallet.getCoinsCount() + 1;
                                                    this.menu.addPoint(lastpoint + ". Specify the amount of " + wallet.getCoinName(currency) + " coins");
                                                    this.menu.setPoint(lastpoint);
                                                    do {
                                                        pw.println(this.menu);
                                                        pw.flush();
                                                        command = br.readLine().trim();
                                                    } while (! this.menu.checkCommand(command));
                                                    int point = this.getNumber(command);
                                                    if (point > 0) {
                                                        if (point < lastpoint) {
                                                            BigDecimal sold = wallet.getCoins(point - 1);
                                                            BigDecimal bought = market.deal(currency, point - 1, wallet.getCoins(point - 1), wallet, new BigInteger(pin, 16));
                                                            if (bought.compareTo(BigDecimal.ZERO) > 0) {
                                                                pw.println();
                                                                pw.println("Sold " + sold + " " + wallet.getCoinName(point - 1) + " coins");
                                                                pw.println("Bought " + bought + " " + wallet.getCoinName(currency) + " coins");
                                                                pw.println("At price:");
                                                                pw.println("1 " + wallet.getCoinName(point - 1) + " coin = " + bought.divide(sold, 12, BigDecimal.ROUND_UP) + " " + wallet.getCoinName(currency) + " coins");
                                                                pw.println("1 " + wallet.getCoinName(currency) + " coin = " + sold.divide(bought, 12, BigDecimal.ROUND_DOWN) + " " + wallet.getCoinName(point - 1) + " coins");
                                                            } else {
                                                                pw.println();
                                                                pw.println("Trade canceled");
                                                            }
                                                        } else {
                                                            pw.println();
                                                            pw.println("Amount: ");
                                                            pw.flush();
                                                            String amt = br.readLine().trim().replace(',', '.');
                                                            while (! isDigit(amt)) {
                                                                pw.println();
                                                                pw.println("The input value of amount is not a number");
                                                                pw.println();
                                                                pw.println("Amount: ");
                                                                pw.flush();
                                                                amt = br.readLine().trim().replace(',', '.');                                                                
                                                            }
                                                            BigDecimal amount = new BigDecimal(amt);
                                                            if (amount.compareTo(BigDecimal.ZERO) > 0) {
                                                                this.menu = new Menu();
                                                                boolean variants = false;
                                                                for (int i = 0; i < wallet.getCoinsCount(); i++) {
                                                                    if (i != currency) {
                                                                        BigDecimal price = market.getReversePrice(currency, i, amount);
                                                                        if (price.compareTo(BigDecimal.ZERO) > 0) {
                                                                            int n = i + 1;
                                                                            BigDecimal firstvolume = market.getReversePrice(currency, i, amount).multiply(amount).divide(BigDecimal.ONE, 6, BigDecimal.ROUND_UP);
                                                                            if (wallet.getCoins(i).compareTo(firstvolume) > 0) {
                                                                                price = firstvolume.divide(amount, 12, BigDecimal.ROUND_UP);
                                                                                this.menu.addPoint(n + ". Buy " + amt + " " + wallet.getCoinName(currency) + " coins, sell ~" + firstvolume + " " + wallet.getCoinName(i) + " coins at price: 1 " + wallet.getCoinName(currency) + " coin ~ " + price + " " + wallet.getCoinName(i) + " coins");
                                                                                this.menu.setPoint(n);
                                                                                variants = true;
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                                if (variants) {
                                                                    do { 
                                                                        pw.println(this.menu);
                                                                        pw.flush();
                                                                        this.command = br.readLine().trim();
                                                                    } while (! this.menu.checkCommand(command));
                                                                    point = Integer.parseInt(this.command);
                                                                    if (point != 0) {
                                                                        BigDecimal bought = amount;
                                                                        BigDecimal sold = market.reverseDeal(currency, point - 1, amount, wallet, new BigInteger(pin, 16));;
                                                                        if (bought.compareTo(BigDecimal.ZERO) > 0) {
                                                                            pw.println();
                                                                            pw.println("Sold " + sold + " " + wallet.getCoinName(point - 1) + " coins");
                                                                            pw.println("Bought " + bought + " " + wallet.getCoinName(currency) + " coins");
                                                                            pw.println("At price:");
                                                                            pw.println("1 " + wallet.getCoinName(currency) + " coin = " + sold.divide(bought, 12, BigDecimal.ROUND_UP) + " " + wallet.getCoinName(point - 1) + " coins");
                                                                            pw.println("1 " + wallet.getCoinName(point - 1) + " coin = " + bought.divide(sold, 12, BigDecimal.ROUND_DOWN) + " " + wallet.getCoinName(currency) + " coins");
                                                                        } else {
                                                                            pw.println();
                                                                            pw.println("Trade canceled");
                                                                        }
                                                                    }
                                                                } else {
                                                                    pw.println();
                                                                    pw.println("Too large amount of " + wallet.getCoinName(currency) + " coins");
                                                                }
                                                            }
                                                        }
                                                    }
                                                
                                                } 
                                            }
                                        }
                                        if (useraction == '0') {
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }                      
            
                if (useraction == '0') {
                    allow = false;
                }                        
            }
            pw.println("Bye");
            pw.flush();
            socket.close();
        }  catch(Exception ex) {
                //ex.printStackTrace();
        }
  } 
  
  private int getNumber(String number) {
      int result = 0;
      try {
          result = Integer.parseInt(number);
      } catch (Exception ex) {
          result = -1;
      }
      return result;
  }
  
  private boolean isDigit(String s) {
      try {
          new BigDecimal(s);
      } catch (Exception ex) {
          return false;
      }
      return true;
  }
  
  private BigInteger get128bitsNumber() {
        BigInteger result = new BigInteger(128, this.rand);
        while (result.bitLength() != 128) {
            result = new BigInteger(128, this.rand);
        }
        return result;
  }
  
  private boolean isBigIntegerDigit(String s) {
      try {
          new BigInteger(s, 16);
      } catch (Exception ex) {
          return false;
      }
      return true;
  }
  
  
}