/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package paymentsystem;

import java.util.*;
import java.math.*;
import java.io.*;

/**
 *
 * @author Yury V. Reshetov
 */
public class PaymentSystem {
    private TreeMap wallets = new TreeMap();
    private LogsManager lm = new LogsManager();
    private Market market = new Market(lm);
    
    public PaymentSystem() {
        try {
            File f = new File("logs");
            if (! f.exists()) {
                f.mkdir();
            }
        } catch (Exception ex) {
            
        }
    }
    
    public Market getMarket() {
        return this.market;
    }
    
    public Wallet getWallet(BigInteger number) {
        Wallet wallet = null;
        if (this.wallets.containsKey(number.toString(16))) {
            wallet = (Wallet)this.wallets.get(number.toString(16));
        } else {
            try {
                File f = new File(number.toString(16) + ".txt");
                if (f.exists()) {
                    BufferedReader br = new BufferedReader(new FileReader(f));
                    String version = br.readLine().trim();
                    wallet = new Wallet(number, this.lm);
                    String coins[] = new String[wallet.getCoinsCount()];
                    for (int i = 0; i < wallet.getCoinsCount(); i++) {
                        coins[i] = br.readLine().trim();
                        wallet.addCoins(new BigDecimal(coins[i]), i);
                    }
                    br.close();
                    this.wallets.put(number.toString(16), wallet);
                }
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        return wallet;
    }
    
    public boolean deleteWallet(BigInteger number, BigInteger pin) {
        try {
            File f = new File(number.toString(16) + ".txt");
            if (f.exists()) {
                Wallet wallet = this.getWallet(number);
                f.delete();
                this.wallets.remove(number.toString(16));
            } else {
                return false;
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return true;
    } 
    
    public LogsManager getLogsManager() {
        return this.lm;
    }
}
