/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package paymentsystem;

import java.math.*;
import java.io.*;

/**
 *
 * @author Yury V. Reshetov
 */

public class Wallet {
    private final int coinscount = 4;
    private BigInteger number = null;
    private BigDecimal[] coins = new BigDecimal[coinscount];
    private BigDecimal version = BigDecimal.ONE;
    private LogsManager lm = null;
    
    public Wallet(BigInteger number, LogsManager logsmanager) {
        this.lm = logsmanager;
        for (int i = 0; i < coins.length; i++) {
            coins[i] = BigDecimal.ZERO;
        }
        this.number = number;
    }
    
    public BigInteger getNumber() {
        return this.number;
    }
    
    /*
    public boolean changePin(BigInteger pincode) {
        return this.pin.equals(pincode);
    }
     * 
     */
    
    public BigDecimal getCoins(int indexcoin) {
        if (indexcoin < 0) {
            return BigDecimal.ZERO;
        }
        if (indexcoin > this.coins.length) {
            return BigDecimal.ZERO;
        }
        return this.coins[indexcoin];
    }
    
    public int getCoinsCount() {
        return coinscount;
    }
    
    public boolean subtractCoins(BigDecimal money, int indexcoin, BigInteger consumer) {
        if (indexcoin < 0) {
            return false;
        }
        if (indexcoin >= coinscount) {
            return false;
        }
        if (money.compareTo(BigDecimal.ZERO) < 0) {
            return false;
        }
        this.coins[indexcoin] = this.coins[indexcoin].subtract(money);
        this.save();
        this.lm.setLog(this.number, consumer, indexcoin, money);
        return true;
    }


    public boolean addCoins(BigDecimal money, int indexcoin) {
        if (indexcoin < 0) {
            return false;
        }
        if (indexcoin >= coinscount) {
            return false;
        }
        if (money.compareTo(BigDecimal.ZERO) < 0) {
            return false;
        }
        this.coins[indexcoin] = this.coins[indexcoin].add(money);
        this.save();
        return true;
    }
    
    
    private void save() {
        try {
            File f = new File(this.number.toString(16) + ".txt");
            PrintWriter pw = new PrintWriter(new FileWriter(f));
            pw.println(this.version);
            for (int i = 0; i < coinscount; i++) {
                pw.println(this.coins[i]);
            }
            pw.flush();
            pw.close();
        } catch (Exception ex) {
            ex.printStackTrace();  
        }
    }
    
    public String getCoinName(int indexcoin) {
      if (indexcoin < 0) {
          return "";
      }
      if (indexcoin >= coinscount) {
          return "";
      }
      if (indexcoin == 0) {
          return "White";
      }
      if (indexcoin == 1) {
          return "Red";
      }
      if (indexcoin == 2) {
          return "Green";
      }
      return "Black";
  }
    
  public boolean isHaveConvertCoins() {
      boolean result = false;
      for (int i = 0; i < (this.coins.length - 1); i++) {
          if (this.coins[i].compareTo(BigDecimal.ZERO) > 0) {
              return true;
          }
      }
      return result;
  }
  
    public boolean isHaveCoinsExcept(int except) {
      boolean result = false;
      for (int i = 0; i < this.coins.length; i++) {
          if (except != i) {
            if (this.coins[i].compareTo(BigDecimal.ZERO) > 0) {
              return true;
            }
          }
      }
      return result;
  }


  public boolean isHaveConvertCoins(int indexcoin) {
      if (this.coins[indexcoin].compareTo(BigDecimal.ZERO) > 0) {
          return true;
      }
      return false;
  }
  
  public boolean isCorrectAmount(BigDecimal amount, int indexcoin) {
      return (amount.compareTo(this.coins[indexcoin]) <= 0);
  }
}
